// This file is auto-generated by @hey-api/openapi-ts

export type BodyLoginLoginAccessToken = {
    grant_type?: string | null;
    username: string;
    password: string;
    scope?: string;
    client_id?: string | null;
    client_secret?: string | null;
};

export type BodyShopLoginAccessToken = {
    grant_type?: string | null;
    username: string;
    password: string;
    scope?: string;
    client_id?: string | null;
    client_secret?: string | null;
};

export type HttpValidationError = {
    detail?: Array<ValidationError>;
};

export type Token = {
    access_token: string;
    token_type?: string;
};

export type UserRegister = {
    username: string;
    email: string;
    phone_number: string;
    /**
     * Password must be at least 8 and at most 128 characters long, contain a lower case, upper case letter, a number and a special character (#?!@$ %^&*-)
     */
    password: string;
};

export type ValidationError = {
    loc: Array<string | number>;
    msg: string;
    type: string;
};

export type CartShowCartData = {
    body?: never;
    path?: never;
    query?: never;
    url: '/cart/';
};

export type CartShowCartResponses = {
    /**
     * Successful Response
     */
    200: unknown;
};

export type CartAddToCartData = {
    body?: never;
    path: {
        product_id: number;
    };
    query?: {
        /**
         * Count must be greater than or equal to 1
         */
        count?: number;
    };
    url: '/cart/add/{product_id}';
};

export type CartAddToCartErrors = {
    /**
     * Validation Error
     */
    422: HttpValidationError;
};

export type CartAddToCartError = CartAddToCartErrors[keyof CartAddToCartErrors];

export type CartAddToCartResponses = {
    /**
     * Successful Response
     */
    200: unknown;
};

export type CartRemoveFromCartData = {
    body?: never;
    path: {
        product_id: number;
    };
    query?: never;
    url: '/cart/remove/{product_id}';
};

export type CartRemoveFromCartErrors = {
    /**
     * Validation Error
     */
    422: HttpValidationError;
};

export type CartRemoveFromCartError = CartRemoveFromCartErrors[keyof CartRemoveFromCartErrors];

export type CartRemoveFromCartResponses = {
    /**
     * Successful Response
     */
    200: unknown;
};

export type CartUpdateCountInCartData = {
    body?: never;
    path: {
        product_id: number;
    };
    query: {
        /**
         * Count must be provided
         */
        count: number;
    };
    url: '/cart/update/{product_id}';
};

export type CartUpdateCountInCartErrors = {
    /**
     * Validation Error
     */
    422: HttpValidationError;
};

export type CartUpdateCountInCartError = CartUpdateCountInCartErrors[keyof CartUpdateCountInCartErrors];

export type CartUpdateCountInCartResponses = {
    /**
     * Successful Response
     */
    200: unknown;
};

export type CartPurchaseData = {
    body?: never;
    path?: never;
    query?: never;
    url: '/cart/purchase';
};

export type CartPurchaseResponses = {
    /**
     * Successful Response
     */
    200: unknown;
};

export type UserDeleteUserData = {
    body?: never;
    path?: never;
    query?: never;
    url: '/user/delete';
};

export type UserDeleteUserResponses = {
    /**
     * Successful Response
     */
    200: unknown;
};

export type UserLogoutData = {
    body?: never;
    path?: never;
    query?: never;
    url: '/user/logout';
};

export type UserLogoutResponses = {
    /**
     * Successful Response
     */
    200: unknown;
};

export type UserRegisterData = {
    body: UserRegister;
    path?: never;
    query?: never;
    url: '/user/register';
};

export type UserRegisterErrors = {
    /**
     * Validation Error
     */
    422: HttpValidationError;
};

export type UserRegisterError = UserRegisterErrors[keyof UserRegisterErrors];

export type UserRegisterResponses = {
    /**
     * Successful Response
     */
    200: unknown;
};

export type UserUpdateUserData = {
    body: {
        [key: string]: unknown;
    };
    path?: never;
    query?: never;
    url: '/user/update';
};

export type UserUpdateUserErrors = {
    /**
     * Validation Error
     */
    422: HttpValidationError;
};

export type UserUpdateUserError = UserUpdateUserErrors[keyof UserUpdateUserErrors];

export type UserUpdateUserResponses = {
    /**
     * Successful Response
     */
    200: unknown;
};

export type UtilsHealthCheckData = {
    body?: never;
    path?: never;
    query?: never;
    url: '/utils/health-check/';
};

export type UtilsHealthCheckResponses = {
    /**
     * Successful Response
     */
    200: boolean;
};

export type UtilsHealthCheckResponse = UtilsHealthCheckResponses[keyof UtilsHealthCheckResponses];

export type UtilsTestDbData = {
    body?: never;
    path?: never;
    query?: never;
    url: '/utils/test-db/';
};

export type UtilsTestDbResponses = {
    /**
     * Successful Response
     */
    200: boolean;
};

export type UtilsTestDbResponse = UtilsTestDbResponses[keyof UtilsTestDbResponses];

export type LoginLoginAccessTokenData = {
    body: BodyLoginLoginAccessToken;
    path?: never;
    query?: never;
    url: '/login/access-token';
};

export type LoginLoginAccessTokenErrors = {
    /**
     * Validation Error
     */
    422: HttpValidationError;
};

export type LoginLoginAccessTokenError = LoginLoginAccessTokenErrors[keyof LoginLoginAccessTokenErrors];

export type LoginLoginAccessTokenResponses = {
    /**
     * Successful Response
     */
    200: Token;
};

export type LoginLoginAccessTokenResponse = LoginLoginAccessTokenResponses[keyof LoginLoginAccessTokenResponses];

export type ShopLoginAccessTokenData = {
    body: BodyShopLoginAccessToken;
    path?: never;
    query?: never;
    url: '/shop/{shop_uuid}/login/access-token';
};

export type ShopLoginAccessTokenErrors = {
    /**
     * Validation Error
     */
    422: HttpValidationError;
};

export type ShopLoginAccessTokenError = ShopLoginAccessTokenErrors[keyof ShopLoginAccessTokenErrors];

export type ShopLoginAccessTokenResponses = {
    /**
     * Successful Response
     */
    200: Token;
};

export type ShopLoginAccessTokenResponse = ShopLoginAccessTokenResponses[keyof ShopLoginAccessTokenResponses];

export type ShopDeleteUserData = {
    body?: never;
    path: {
        shop_uuid: unknown;
    };
    query?: never;
    url: '/shop/{shop_uuid}/user/delete';
};

export type ShopDeleteUserErrors = {
    /**
     * Validation Error
     */
    422: HttpValidationError;
};

export type ShopDeleteUserError = ShopDeleteUserErrors[keyof ShopDeleteUserErrors];

export type ShopDeleteUserResponses = {
    /**
     * Successful Response
     */
    200: unknown;
};

export type ShopLogoutData = {
    body?: never;
    path?: never;
    query?: never;
    url: '/shop/{shop_uuid}/user/logout';
};

export type ShopLogoutResponses = {
    /**
     * Successful Response
     */
    200: unknown;
};

export type ShopRegisterData = {
    body: UserRegister;
    path: {
        shop_uuid: unknown;
    };
    query?: never;
    url: '/shop/{shop_uuid}/user/register';
};

export type ShopRegisterErrors = {
    /**
     * Validation Error
     */
    422: HttpValidationError;
};

export type ShopRegisterError = ShopRegisterErrors[keyof ShopRegisterErrors];

export type ShopRegisterResponses = {
    /**
     * Successful Response
     */
    200: unknown;
};

export type ShopUpdateUserData = {
    body: {
        [key: string]: unknown;
    };
    path?: never;
    query?: never;
    url: '/shop/{shop_uuid}/user/update';
};

export type ShopUpdateUserErrors = {
    /**
     * Validation Error
     */
    422: HttpValidationError;
};

export type ShopUpdateUserError = ShopUpdateUserErrors[keyof ShopUpdateUserErrors];

export type ShopUpdateUserResponses = {
    /**
     * Successful Response
     */
    200: unknown;
};

export type ClientOptions = {
    baseURL: 'http://localhost:8000' | (string & {});
};